#ifndef readpoly_header
#define readpoly_header

#include<iostream>
#include<fstream>
#include<string>
#include<stdio.h>
#include<stdlib.h>
#include<cmath>

using namespace std;

#define MAXSIZE 1000

template <int degree>
class poly{
	private:
		
		double eval_point;
		double roots[degree];
		double coeff[degree+1];
		
		
	public:
		int is_root(int root);
		poly(ifstream &filename);
		void print();
		};
		
	template <int degree>
	poly<degree>::poly(ifstream &readfile){
		string line;
	int counter(0);
		if(readfile.is_open()){
			while (getline(readfile, line)){
				if (counter<=degree){
					coeff[counter]=strtod(line.c_str(), NULL);
					}
				else if (counter>degree-1){
					roots[counter-3]=strtod(line.c_str(), NULL);
					}
				counter++;
				}
				readfile.close();
	 }
	 else cout<<"Unable to open file"<<endl;

		}//constructor
		
		
template<int degree>
int poly<degree>::is_root(int root){
	double sum=0;
	for (int i=0; i<=degree; i++){
		sum+=coeff[i]*pow(roots[root], degree-i);
		}
		if (!sum){
			return 1;
			}
		else{
			return 0;
			}
	}
			
template<int degree>
void poly<degree>::print(){
	cout<<"The polynomial is: "<<coeff[0]<<"*x^"<<degree;
	for (int i=1; i<=degree; i++){
				cout<<"+"<<coeff[i]<<"*x^"<<degree-i;
				}
	cout<<endl;
	cout<<"The given roots are: ";
	for (int j = 0; j<degree; j++){
		cout<<"x = "<<roots[j]<<", ";
		}
		cout<<endl;
		}
	
	
#endif

